> ## Documentation Index
> Fetch the complete documentation index at: https://kb.talostrading.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Full block

> Returns a full blockchain block with all transactions and balance updates.<br/> Results are limited to the last 30 days for Community users.



## OpenAPI

````yaml /coinmetrics/openapi/coinmetrics.yaml get /blockchain-v2/{asset}/blocks/{block_hash}
openapi: 3.0.2
info:
  title: Coin Metrics API v4
  description: >-
    [Coin Metrics Homepage](https://coinmetrics.io/)<br/> [API Backward
    Compatibility
    Policy](https://docs.coinmetrics.io/access-our-data/api#backward-compatibility)<br/>
    [Python API
    Client](https://coinmetrics.github.io/api-client-python/site/index.html)<br/><br/>

    HTTP API root endpoint URL is `https://api.coinmetrics.io/v4`. Coin
    Metrics&apos; paid product.<br/> WebSocket API root endpoint is
    `wss://api.coinmetrics.io/v4`. Coin Metrics&apos; paid product.<br/><br/>
    The Community HTTP API root endpoint URL is
    `https://community-api.coinmetrics.io/v4`. API key is not required when
    accessing community endpoints. Available to the community under the
    [Creative Commons](https://creativecommons.org/licenses/by-nc/4.0/) license.

    # Authentication

    <!-- ReDoc-Inject: <security-definitions> -->

    # Response headers

    Note that Coin Metrics API responses have a `CF-RAY` HTTP header e.g.
    `88a6ec1d2f930774-IAD` which can be used for diagnostic purposes. When
    raising Support requests, please ensure to provide the value of this
    header. 
  termsOfService: https://coinmetrics.io/api/terms
  contact:
    name: Coin Metrics Support
    url: https://coinmetrics.io/support/
    email: support@coinmetrics.io
  license:
    name: Apache 2.0
    url: https://www.apache.org/licenses/LICENSE-2.0.html
  version: 4.0.0
servers:
  - url: https://api.coinmetrics.io/v4
  - url: wss://api.coinmetrics.io/v4
  - url: https://community-api.coinmetrics.io/v4
security: []
tags:
  - name: Rate limits
    description: >-
      To ensure the quality of Coin Metrics services, API is subject to rate
      limiting.<br/> <table> <tr><th>Rate Limit Plan</th><th>REST API: Requests
      per Second (sliding window)</th><th>REST API: Download Speed</th><th>REST
      API: Max Parallel Requests</th><th>WebSocket API: Max Parallel
      Connections</th></tr> <tr><td>Community</td><td>10 requests per 6 seconds
      per IP address</td><td>Reduced speed</td><td>10</td><td>N/A</td></tr>
      <tr><td>Trial</td><td>10 requests per 6 seconds per API key</td><td>Max
      speed</td><td>10</td><td>200</td></tr> <tr><td>Default (PRO)</td><td>6000
      requests per 20 seconds per API key</td><td>Standard
      speed</td><td>10</td><td>200</td></tr> <tr><td>Download (PRO)</td><td>6000
      requests per 20 seconds per API key</td><td>Max
      speed</td><td>10</td><td>200</td></tr> </table> <br/> All PRO keys by
      default get the "default" rate limits. To download historical data at max
      speed, you need to switch to the "download" plan. <br/> <br/> The paid and
      community versions of the API have a limit of 10 parallel REST API
      requests. After this limit is reached, further parallel requests will be
      queued, so performance will be slower.<br/> <br/> If you reach the
      request-per-second limit, API starts to return `429 Too Many Requests`
      HTTP response status.<br/> API also provides `X-RateLimit-*` response
      headers formatted according to
      https://tools.ietf.org/html/draft-polli-ratelimit-headers-03.<br/>
      Additionally, the API provides the `X-RateLimit-Plan` header which
      indicates the current rate limiting plan. This header may have values:
      `default`, `trial`, `download`, or `community`.
    x-cm-gitbook:
      foldIntoInfo: true
  - name: Reference Data
    description: Metadata information of entities supported by Coin Metrics.
    x-cm-gitbook:
      tag: Meta Data
      icon: book
  - name: Catalog
    x-displayName: Catalog (deprecated)
    description: >-
      Catalog of available for your `api_key` data.<br/> Use the [Full
      catalog](#tag/Full-catalog) endpoints for the full list of supported by
      Coin Metrics data. <br/>DEPRECATED: See
      https://coinmetrics.io/important-changes-to-coin-metrics-api-catalog-endpoints/.
    x-cm-gitbook:
      remove: true
  - name: Catalog v2
    description: >-
      Catalog of available for your `api_key` data.<br/> Use the [Full catalog
      V2](#tag/Full-catalog-v2) endpoints for the full list of supported by Coin
      Metrics data.
    x-cm-gitbook:
      icon: list-check
  - name: Full catalog
    x-displayName: Full catalog (deprecated)
    description: >-
      The Full catalog returns the full range of data that is supported by Coin
      Metrics across all our products.<br/> If you are a client looking to
      understand the data that is available for your API key and data license,
      please use the [Catalog](#tag/Catalog) endpoint. <br/>DEPRECATED: See
      https://coinmetrics.io/important-changes-to-coin-metrics-api-catalog-endpoints/.
    x-cm-gitbook:
      remove: true
  - name: Full catalog v2
    description: >-
      The Full catalog returns the full range of data that is supported by Coin
      Metrics across all our products.<br/> If you are a client looking to
      understand the data that is available for your API key and data license,
      please use the [Catalog](#tag/Catalog-v2) endpoint.
    x-cm-gitbook:
      tag: Catalog v2
      icon: layer-group
  - name: Timeseries
    description: >-
      Endpoints for fetching metrics, market data, indexes and other time series
      data.
    x-cm-gitbook:
      icon: chart-line
      renameOperationsTo: Timeseries REST
  - name: Timeseries stream
    description: >-
      WebSocket endpoints for getting a real-time stream of metrics, market
      data, indexes and other time series data.
    x-cm-gitbook:
      tag: Timeseries
      icon: wifi
  - name: Taxonomy
    description: Taxonomy endpoints
    x-cm-gitbook:
      icon: sitemap
  - name: Taxonomy Metadata
    description: Taxonomy Metadata endpoints
    x-cm-gitbook:
      tag: Taxonomy
      icon: tags
  - name: Profile
    description: Profile endpoints
    x-cm-gitbook:
      tag: Meta Data
      icon: id-card
  - name: List of blockchain entities v2
    description: Endpoints for fetching lists of blockchain entities.
    x-cm-gitbook:
      tag: ATLAS
      icon: list
  - name: Full blockchain entities v2
    description: Endpoints for fetching full blockchain entities.
    x-cm-gitbook:
      tag: List of blockchain entities v2
      icon: database
  - name: Jobs
    description: Jobs API endpoints
    x-cm-gitbook:
      tag: ATLAS
      icon: briefcase
  - name: Blockchain Explorer Job
    description: Endpoints for creating async jobs for blockchain entities.
    x-cm-gitbook:
      tag: ATLAS
      icon: clock
  - name: Blockchain Explorer Job Results
    description: Schema definitions of results of Blockchain Explorer Job endpoints.
    x-cm-gitbook:
      foldInto: Blockchain Explorer Job
  - name: Chain Monitor tools
    description: Endpoints for working with chain monitor data.
    x-cm-gitbook:
      tag: ATLAS
      icon: wrench
  - name: Security Master
    description: Security Master endpoints
    x-cm-gitbook:
      tag: Meta Data
      icon: shield
  - name: Constituent Snapshots
    description: Endpoints for getting the snapshots of various constituents
    x-cm-gitbook:
      tag: Meta Data
      icon: camera
  - name: Constituent Timeframes
    description: Endpoints for getting the timeframes of various constituents
    x-cm-gitbook:
      tag: Meta Data
      icon: calendar
  - name: Blockchain Metadata
    description: Blockchain metadata endpoints
    x-cm-gitbook:
      tag: Meta Data
      icon: database
  - name: Meta Data
    x-cm-gitbook:
      icon: database
  - name: ATLAS
    x-cm-gitbook:
      icon: map
  - name: Timeseries REST
    x-cm-gitbook:
      tag: Timeseries
      icon: table
paths:
  /blockchain-v2/{asset}/blocks/{block_hash}:
    servers:
      - url: https://api.coinmetrics.io/v4
      - url: https://community-api.coinmetrics.io/v4
    get:
      tags:
        - Full blockchain entities v2
      summary: Full block
      description: >-
        Returns a full blockchain block with all transactions and balance
        updates.<br/> Results are limited to the last 30 days for Community
        users.
      operationId: getBlockchainV2FullBlock
      parameters:
        - $ref: '#/components/parameters/BlockchainAsset'
        - $ref: '#/components/parameters/BlockchainBlockHash'
        - $ref: '#/components/parameters/BlockchainIncludeSubAccountsV2'
        - $ref: '#/components/parameters/Pretty'
        - $ref: '#/components/parameters/IgnoreUnsupportedErrors'
      responses:
        '200':
          $ref: '#/components/responses/BlockchainFullBlockV2'
        '401':
          $ref: '#/components/responses/Unauthorized'
        '403':
          $ref: '#/components/responses/BlockchainForbidden'
      security:
        - api_key: []
      x-codeSamples:
        - lang: Shell
          label: Shell
          source: >
            # Gets block data for a specific Litecoin block, specified by the
            hash of the block

            curl --compressed
            "https://api.coinmetrics.io/v4/blockchain-v2/ltc/blocks/885f0ba526e9a683f64c8fdb83c5e8cbc0d6e74fb93f2351941ee409a924b7a8?pretty=true&api_key=<your_key>"
        - lang: Python
          label: Python
          source: >
            # Gets block data for a specific Litecoin block, specified by the
            hash of the block

            import requests

            response =
            requests.get('https://api.coinmetrics.io/v4/blockchain-v2/ltc/blocks/885f0ba526e9a683f64c8fdb83c5e8cbc0d6e74fb93f2351941ee409a924b7a8?pretty=true&api_key=<your_key>').json()

            print(response)
        - lang: Python
          label: Python Client
          source: >
            # Gets block data for a specific Litecoin block, specified by the
            hash of the block

            from coinmetrics.api_client import CoinMetricsClient

            client = CoinMetricsClient(<your_key>)


            response = client.get_list_of_blocks_v2(asset="ltc",
            block_hash="885f0ba526e9a683f64c8fdb83c5e8cbc0d6e74fb93f2351941ee409a924b7a8").to_list()

            print(response)
components:
  parameters:
    BlockchainAsset:
      description: Asset name.
      in: path
      name: asset
      required: true
      schema:
        type: string
    BlockchainBlockHash:
      description: Block hash.
      in: path
      name: block_hash
      required: true
      schema:
        type: string
    BlockchainIncludeSubAccountsV2:
      description: >-
        Boolean indicating if the response should contain sub-accounts.<br/>
        This parameter is disabled for Community users.
      in: query
      name: include_sub_accounts
      schema:
        type: boolean
        default: false
    Pretty:
      description: Human-readable formatting of JSON responses.
      in: query
      name: pretty
      schema:
        type: boolean
        default: false
    IgnoreUnsupportedErrors:
      description: >-
        Ignore "unsupported" errors for not currently supported by Coin Metrics
        items.
      in: query
      name: ignore_unsupported_errors
      schema:
        type: boolean
        default: false
  responses:
    BlockchainFullBlockV2:
      description: Blockchain full block.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/BlockchainFullBlockResponseV2'
          example:
            block_hash: 0000000000000000000079fca9c54dd7532d139ed258f02e3d1368e7006157d9
            height: '758506'
            consensus_time: '2022-10-13T18:27:09.000000000Z'
            miner_time: '2022-10-13T18:57:56.000000000Z'
            n_transactions: '469'
            n_balance_updates: '7425'
            transactions:
              - txid: >-
                  232687100669217c7335d2b2b6f5e7ae61cc6d4c79b8b1b1c7a1fa21938422b9
                consensus_time: '2022-10-13T18:27:09.000000000Z'
                tx_position: '3257758463819776'
                n_balance_updates: '4'
                amount: '6.34186444'
                balance_updates:
                  - chain_sequence_number: '3257758463819776'
                    account: FEES
                    account_creation_height: '0'
                    change: '-0.09186444'
                    rebasing_numerator: '1'
                    rebasing_denominator: '1'
                    rebasing_rounding_mode: DOWN
                    previous_balance: '0'
                    new_balance: '-0.09186444'
                    transaction_sequence_number: '0'
                    n_debits: '758507'
                    n_credits: '771183299'
                    previous_debit_height: '758505'
                    previous_credit_height: '758505'
                    previous_chain_sequence_number: '3257754168874991'
                  - chain_sequence_number: '3257758463819777'
                    account: ISSUANCE
                    account_creation_height: '0'
                    change: '-6.25'
                    rebasing_numerator: '1'
                    rebasing_denominator: '1'
                    rebasing_rounding_mode: DOWN
                    previous_balance: '-19178133.54497096'
                    new_balance: '-19178139.79497096'
                    transaction_sequence_number: '0'
                    n_debits: '758507'
                    n_credits: '0'
                    previous_debit_height: '758505'
                    previous_chain_sequence_number: '3257754168852481'
                min_chain_sequence_number: '3257758463819776'
                max_chain_sequence_number: '3257758463819779'
            balance_updates: []
            parent_block_hash: 000000000000000000079a2d36f1308ea00fd26fda92fe12c5dd4e1a5b0c15e7
            difficulty: '35610794164371.65'
            physical_size: '1075674'
            consensus_size: '3993099'
            consensus_size_limit: '4000000'
    Unauthorized:
      description: Requested resource requires authorization.
      content:
        application/json:
          examples:
            unauthorized:
              summary: Unauthorized error response.
              value:
                error:
                  type: unauthorized
                  message: Requested resource requires authorization.
            wrong_credentials:
              summary: Wrong credentials error response.
              value:
                error:
                  type: wrong_credentials
                  message: Supplied credentials are not valid.
          schema:
            $ref: '#/components/schemas/ErrorResponse'
    BlockchainForbidden:
      content:
        application/json:
          example:
            error:
              type: forbidden
              message: Requested resource is not available with supplied credentials.
          schema:
            $ref: '#/components/schemas/ErrorResponse'
      description: Requested resource is not available with supplied credentials.
  schemas:
    BlockchainFullBlockResponseV2:
      allOf:
        - $ref: '#/components/schemas/BlockchainBlockInfoV2'
        - type: object
          description: Blockchain full block response.
          properties:
            transactions:
              $ref: '#/components/schemas/BlockchainFullTransactionsV2'
            balance_updates:
              $ref: '#/components/schemas/BlockchainTransactionBalanceUpdatesV2'
    ErrorResponse:
      properties:
        error:
          $ref: '#/components/schemas/ErrorObject'
      required:
        - error
      type: object
    BlockchainBlockInfoV2:
      properties:
        block_hash:
          $ref: '#/components/schemas/BlockchainBlockHash'
        parent_block_hash:
          $ref: '#/components/schemas/BlockchainBlockHash'
        height:
          $ref: '#/components/schemas/BlockchainBlockHeight'
        consensus_time:
          $ref: '#/components/schemas/Time'
        miner_time:
          $ref: '#/components/schemas/Time'
        nonce:
          $ref: '#/components/schemas/BlockchainBlockNonce'
        extra_data:
          $ref: '#/components/schemas/BlockchainBlockExtraData'
        n_transactions:
          $ref: '#/components/schemas/BlockchainNumberOfTransactions'
        n_balance_updates:
          $ref: '#/components/schemas/BlockchainNumberOfBalanceUpdates'
        version:
          $ref: '#/components/schemas/BlockchainBlockVersion'
        difficulty:
          $ref: '#/components/schemas/BlockchainBlockDifficulty'
        physical_size:
          $ref: '#/components/schemas/BlockchainBlockPhysicalSize'
        consensus_size:
          $ref: '#/components/schemas/BlockchainBlockConsensusSize'
        consensus_size_limit:
          $ref: '#/components/schemas/BlockchainBlockConsensusSizeLimit'
        stale:
          $ref: '#/components/schemas/BlockchainStaleBlock'
      required:
        - block_hash
        - height
        - consensus_time
        - export_time
        - miner_time
        - n_transactions
        - n_balance_updates
    BlockchainFullTransactionsV2:
      type: array
      items:
        $ref: '#/components/schemas/BlockchainFullTransactionResponseV2'
    BlockchainTransactionBalanceUpdatesV2:
      type: array
      items:
        $ref: '#/components/schemas/BlockchainTransactionBalanceUpdateV2'
    ErrorObject:
      properties:
        type:
          description: Error type string. Can be used for error identification.
          type: string
        message:
          description: >-
            Human-friendly error description. Can be amended without prior
            notification. Do not use for error identification in your code.
          type: string
      required:
        - type
        - description
      type: object
    BlockchainBlockHash:
      description: Hash of the block.
      type: string
    BlockchainBlockHeight:
      description: Height of the block.
      type: string
      format: int64
    Time:
      description: >-
        The time in ISO 8601 date-time format. Always with nanoseconds
        precision.
      type: string
      format: date-time
    BlockchainBlockNonce:
      description: Nonce of the block, hex-encoded.
      type: string
    BlockchainBlockExtraData:
      description: Extra data of the block, hex-encoded.
      type: string
    BlockchainNumberOfTransactions:
      description: Number of transactions.
      type: string
      format: int64
    BlockchainNumberOfBalanceUpdates:
      description: Number of balance updates.
      type: string
      format: int64
    BlockchainBlockVersion:
      description: Version of the block.
      type: string
    BlockchainBlockDifficulty:
      description: Difficulty of the block.
      type: string
      format: decimal
    BlockchainBlockPhysicalSize:
      description: Physical size of the block, bytes.
      type: string
      format: int64
    BlockchainBlockConsensusSize:
      description: Consensus size of the block.
      type: string
      format: int64
    BlockchainBlockConsensusSizeLimit:
      description: Consensus size limit of the block.
      type: string
      format: int64
    BlockchainStaleBlock:
      description: >-
        This field is set to true if the corresponding block is stale. Otherwise
        omitted.
      type: string
    BlockchainFullTransactionResponseV2:
      allOf:
        - $ref: '#/components/schemas/BlockchainBlockTransactionInfoV2'
        - type: object
          description: Blockchain full transaction response.
          properties:
            balance_updates:
              $ref: '#/components/schemas/BlockchainTransactionBalanceUpdatesV2'
    BlockchainTransactionBalanceUpdateV2:
      properties:
        chain_sequence_number:
          $ref: '#/components/schemas/BlockchainChainSequenceNumber'
        account:
          $ref: '#/components/schemas/BlockchainAccount'
        account_creation_height:
          $ref: '#/components/schemas/BlockchainBlockHeight'
        change:
          $ref: '#/components/schemas/BlockchainBalanceChange'
        rebasing_numerator:
          $ref: '#/components/schemas/BlockchainRebasingNumerator'
        rebasing_denominator:
          $ref: '#/components/schemas/BlockchainRebasingDenominator'
        rebasing_rounding_mode:
          $ref: '#/components/schemas/BlockchainRebasingRoundingMode'
        previous_balance:
          $ref: '#/components/schemas/BlockchainAccountBalance'
        new_balance:
          $ref: '#/components/schemas/BlockchainAccountBalance'
        transaction_sequence_number:
          $ref: '#/components/schemas/BlockchainTransactionSequenceNumber'
        n_debits:
          $ref: '#/components/schemas/BlockchainNumberOfDebits'
        n_credits:
          $ref: '#/components/schemas/BlockchainNumberOfCredits'
        previous_debit_height:
          $ref: '#/components/schemas/BlockchainBlockHeight'
        previous_credit_height:
          $ref: '#/components/schemas/BlockchainBlockHeight'
        previous_chain_sequence_number:
          $ref: '#/components/schemas/BlockchainTransactionSequenceNumber'
        sub_account:
          $ref: '#/components/schemas/BlockchainBalanceUpdateSubAccount'
        stale:
          $ref: '#/components/schemas/BlockchainStaleBlock'
        denomination:
          $ref: '#/components/schemas/BlockchainDenomination'
      required:
        - chain_sequence_number
        - account
        - account_creation_height
        - change
        - previous_balance
        - new_balance
        - transaction_sequence_number
        - n_debits
        - n_credits
    BlockchainBlockTransactionInfoV2:
      properties:
        txid:
          $ref: '#/components/schemas/BlockchainTransactionId'
        consensus_time:
          $ref: '#/components/schemas/Time'
        miner_time:
          $ref: '#/components/schemas/Time'
        tx_position:
          $ref: '#/components/schemas/BlockchainTransactionPosition'
        min_chain_sequence_number:
          $ref: '#/components/schemas/BlockchainChainSequenceNumber'
        max_chain_sequence_number:
          $ref: '#/components/schemas/BlockchainChainSequenceNumber'
        n_balance_updates:
          $ref: '#/components/schemas/BlockchainNumberOfBalanceUpdates'
        amount:
          $ref: '#/components/schemas/BlockchainTransactionAmount'
        stale:
          $ref: '#/components/schemas/BlockchainStaleBlock'
      required:
        - txid
        - consensus_time
        - tx_position
        - n_balance_updates
        - amount
    BlockchainChainSequenceNumber:
      description: Chain sequence number.
      type: string
      format: int64
    BlockchainAccount:
      description: Account id.
      type: string
    BlockchainBalanceChange:
      description: Balance change.
      type: string
      format: decimal
    BlockchainRebasingNumerator:
      description: >-
        This field represents the numerator of the rebasing coefficient at the
        time of the update. This value is omitted from responses if equal to the
        default value of '1'.
      type: string
      format: decimal
    BlockchainRebasingDenominator:
      description: >-
        This field represents the denominator of the rebasing coefficient at the
        time of the update. This value is omitted from responses if equal to the
        default value of '1'.
      type: string
      format: decimal
    BlockchainRebasingRoundingMode:
      description: >-
        This field represents the rounding mode used when converting tokens to
        shares using the rebasing coefficient at the time of the update. The
        possible values are: `UP`, `DOWN`, `HALF_UP`. This value is omitted from
        responses if equal to the default value of `DOWN`.
      type: string
    BlockchainAccountBalance:
      description: Balance of the account.
      type: string
      format: decimal
    BlockchainTransactionSequenceNumber:
      description: >-
        It is used to order balance updates inside a single transaction to
        distinguish between serial and parallel balance updates.
      type: string
      format: int64
    BlockchainNumberOfDebits:
      description: Number of debits.
      type: string
      format: int64
    BlockchainNumberOfCredits:
      description: Number of credits.
      type: string
      format: int64
    BlockchainBalanceUpdateSubAccount:
      properties:
        sub_account:
          $ref: '#/components/schemas/BlockchainSubAccount'
        previous_balance:
          $ref: '#/components/schemas/BlockchainAccountBalance'
        new_balance:
          $ref: '#/components/schemas/BlockchainAccountBalance'
        n_debits:
          $ref: '#/components/schemas/BlockchainNumberOfDebits'
        n_credits:
          $ref: '#/components/schemas/BlockchainNumberOfCredits'
        previous_credit_height:
          $ref: '#/components/schemas/BlockchainBlockHeight'
        previous_debit_height:
          $ref: '#/components/schemas/BlockchainBlockHeight'
        previous_chain_sequence_number:
          $ref: '#/components/schemas/BlockchainTransactionSequenceNumber'
        total_received:
          $ref: '#/components/schemas/BlockchainTotalReceived'
        total_sent:
          $ref: '#/components/schemas/BlockchainTotalSent'
        creation_height:
          $ref: '#/components/schemas/BlockchainBlockHeight'
      required:
        - chain_sequence_number
        - account
        - account_creation_height
        - change
        - transaction_sequence_number
        - previous_n_debits
        - previous_n_credits
    BlockchainDenomination:
      description: >-
        The denomination of the asset transacted. Only set if not the same as
        the asset being queried.
      type: string
    BlockchainTransactionId:
      description: Identifier (txid) of the transaction.
      type: string
    BlockchainTransactionPosition:
      description: Transaction position.
      type: string
      format: int64
    BlockchainTransactionAmount:
      description: Sum of all debits in the transaction.
      type: string
      format: decimal
    BlockchainSubAccount:
      description: Sub-account id.
      type: string
    BlockchainTotalReceived:
      description: Total amount received.
      type: string
      format: decimal
    BlockchainTotalSent:
      description: Total amount sent.
      type: string
      format: decimal
  securitySchemes:
    api_key:
      description: Coin Metrics API key can be specified as `?api_key=` query parameter.
      in: query
      name: api_key
      type: apiKey

````